.386
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\advapi32.inc
include \masm32\include\psapi.inc
include \masm32\include\masm32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\advapi32.lib
includelib \masm32\lib\psapi.lib
includelib \masm32\lib\masm32.lib

return MACRO ARG
	IFNB <ARG>
		IF (OPATTR (ARG)) AND 00000100y
			IF ARG EQ 0
				xor eax, eax
			ELSE
				mov eax, ARG
			ENDIF
		ELSEIFDIFI <eax>, <ARG>
			mov eax, ARG
		ENDIF
	ENDIF
	ret
ENDM

;DISPLAY_FAILURES	EQU		1
NAMESIZE			EQU		300
DOMAINSIZE			EQU		300

DisplayProcess		PROTO :DWORD
ListProcesses		PROTO

.data

szOutHeading		db		"Process ID", 09H, "User", 09H, "Module Name", 0Dh, 0Ah, 0Dh, 0Ah, 0
szOutFormatNoOpen	db		"%08X", 09H, "--- Process Handle Could Not Be Retrieved ---", 0Dh, 0Ah, 0
szOutFormatNoTok	db		"%08X", 09H, "--- Process Token Could Not Be Retrieved ---", 0Dh, 0Ah, 0
szOutFormatNoUSID	db		"%08X", 09H, "--- Process User SID Could Not Be Retrieved ---", 0Dh, 0Ah, 0
szOutFormatNoMem	db		"%08X", 09H, "--- Could Not Assign Memory ---", 0Dh, 0Ah, 0
szOutFormatNoLook	db		"%08X", 09H, "--- Account Lookup Failed ---", 0Dh, 0Ah, 0
szOutFormatNoName	db		"%08X", 09H, "%s", 09H, "--- Module Name Lookup Failed ---", 0Dh, 0Ah, 0
szOutFormat			db		"%08X", 09H, "%s", 09H, "%s", 0Dh, 0Ah, 0
szOutUser			db		"Current User: %s", 0Dh, 0Ah, 0Dh, 0Ah, 0
szRet				db		0Dh, 0Ah, 0

dwBytes				dd		NAMESIZE

.data?

szOutBuffer			db		300 dup (?)
szNameBuffer		db		NAMESIZE DUP (?) 
szDomainBuffer		db		DOMAINSIZE DUP (?) 

.code
start:

	invoke GetUserName, addr szNameBuffer, addr dwBytes

	.if eax != 0
		invoke wsprintf, addr szOutBuffer, addr szOutUser, addr szNameBuffer
		invoke StdOut, addr szOutBuffer
	.endif

	invoke ListProcesses
	
	invoke StdOut, addr szRet
	
	invoke ExitProcess, 0

; ==============
; List Processes
; ==============

ListProcesses PROC
	LOCAL hSnapshot:HANDLE
	LOCAL peData:PROCESSENTRY32
	
	invoke CreateToolhelp32Snapshot, TH32CS_SNAPPROCESS, NULL
	mov hSnapshot, eax
	
	.if eax == INVALID_HANDLE_VALUE
		return FALSE
	.endif
	
	invoke StdOut, addr szOutHeading
	
	mov peData.dwSize, sizeof PROCESSENTRY32
	
	invoke Process32First, hSnapshot, addr peData
	
	.if eax != TRUE
		invoke CloseHandle, hSnapshot
	
		return FALSE
	.endif
	
ListProcesses_Loop:

	invoke DisplayProcess, addr peData

	.if eax == TRUE
		invoke StdOut, addr szOutBuffer

IFDEF DISPLAY_FAILURES
	.else
		invoke StdOut, addr szOutBuffer
ENDIF

	.endif
	
	invoke Process32Next, hSnapshot, addr peData
	
	cmp eax, TRUE
	je	ListProcesses_Loop

	invoke GetLastError
	
	.if eax != ERROR_NO_MORE_FILES
	
		invoke CloseHandle, hSnapshot
	
		return FALSE
	.endif

	invoke CloseHandle, hSnapshot
	
	return TRUE
ListProcesses ENDP

; ====================
; Display process data
; ====================

DisplayProcess PROC ppeData:DWORD
	LOCAL hProcess:HANDLE
	LOCAL hToken:HANDLE
	LOCAL dwPID:DWORD
	LOCAL pData:DWORD
	LOCAL dwBytesRead:DWORD
	LOCAL dwBytesRead2:DWORD
	LOCAL dwSidType:DWORD

	; ------------
	; Save the PID
	; ------------

	mov ecx, ppeData
	mov ecx, [ecx][PROCESSENTRY32.th32ProcessID]
	mov dwPID, ecx
	
	; -----------------------
	; Try to open the process
	; -----------------------

	invoke OpenProcess, PROCESS_QUERY_INFORMATION OR PROCESS_VM_READ, FALSE, ecx
	mov hProcess, eax
	
	.if eax == NULL
		invoke wsprintf, addr szOutBuffer, addr szOutFormatNoOpen, dwPID
		
		return FALSE
	.endif

	; --------------------
	; Try to get the token
	; --------------------

	invoke OpenProcessToken, hProcess, TOKEN_QUERY, addr hToken
	
	.if eax == NULL
		invoke wsprintf, addr szOutBuffer, addr szOutFormatNoTok, dwPID

		invoke CloseHandle, hProcess
		
		return FALSE
	.endif

	; ----------------------
	; Get the structure size
	; ----------------------
	
	invoke GetTokenInformation, hToken, 1, NULL, 0, addr dwBytesRead
	invoke GetLastError
	
	.if eax != 0000007Ah
		invoke wsprintf, addr szOutBuffer, addr szOutFormatNoUSID, dwPID

		invoke CloseHandle, hProcess
		
		return FALSE
	.endif
	
	; -------------
	; Allocate data
	; -------------
	
	invoke GlobalAlloc, GMEM_FIXED, dwBytesRead
	mov pData, eax
	
	.if eax == NULL
		invoke wsprintf, addr szOutBuffer, addr szOutFormatNoMem, dwPID
		
		invoke CloseHandle, hProcess
		
		return FALSE
	.endif
	
	; ---------------------------------------
	; Try to get the User SID (1 = TokenUser)
	; ---------------------------------------
	
	invoke GetTokenInformation, hToken, 1, pData, dwBytesRead, addr dwBytesRead
	
	.if eax == NULL
		invoke wsprintf, addr szOutBuffer, addr szOutFormatNoUSID, dwPID
		
		invoke GlobalFree, pData
		invoke CloseHandle, hProcess
		
		return FALSE
	.endif

	; --------------------------------
	; Use the SID to get the user name
	; --------------------------------
	
	mov dwBytesRead, NAMESIZE
	mov dwBytesRead2, DOMAINSIZE
	
	mov ecx, pData
	invoke LookupAccountSid, NULL, [ecx][TOKEN_USER.User.Sid], addr szNameBuffer, addr dwBytesRead, addr szDomainBuffer, addr dwBytesRead2, addr dwSidType
	
	.if eax == 0
		invoke wsprintf, addr szOutBuffer, addr szOutFormatNoLook, dwPID
		
		invoke GlobalFree, pData
		invoke CloseHandle, hProcess
		
		return FALSE
	.endif
	
	; -------------------
	; Get the module name
	; -------------------
	
	invoke GetModuleFileNameEx, hProcess, NULL, addr szDomainBuffer, DOMAINSIZE
	
	.if eax == 0
		invoke wsprintf, addr szOutBuffer, addr szOutFormatNoName, dwPID, addr szNameBuffer
		
		invoke GlobalFree, pData
		invoke CloseHandle, hProcess
		
		return FALSE
	.endif
	
	add eax, offset szDomainBuffer
	mov [eax], byte ptr 0
	
	; -------------
	; All succeeded
	; -------------
	
	invoke wsprintf, addr szOutBuffer, addr szOutFormat, dwPID, addr szNameBuffer, addr szDomainBuffer
	
	invoke GlobalFree, pData
	invoke CloseHandle, hProcess
	
	return TRUE
DisplayProcess ENDP

end start
